

#include <iostream>
#include <pmonitor/pmonitor.h>
#include "srs.h"

#include <TH1.h>
#include <TH2.h>
#include <TCanvas.h>

int init_done = 0;

using namespace std;


TH1F *trace[16]; 

TH2F *h2; 
TH2F *h3; 

TH2F *h4; 
TH2F *h5; 

TH1F *h_ch40; 
TH1F *h_ch78; 

#define CARDS 4

TCanvas *c_1;
TCanvas *c_2;


int make_display()
{
  c_1 = new TCanvas("c_1");

  c_1->Divide(1,2);
  c_1->cd(1);
  trace[0]->Draw();
 
  c_1->cd(2);
  trace[1]->Draw();

  
  c_2 = new TCanvas("c_2");
  h3->Draw("Lego2");

  return 0;
}


int pinit()
{

  if (init_done) return 1;
  init_done = 1;

  char name[512];
  char title[512];

  int i;
  for ( i = 0; i < CARDS; i++)
    {
      sprintf ( name, "trace_%02d", i);
      sprintf ( title , "hybrid %d", i);
      trace[i] = new TH1F( name, title, 4500, -0.5, 4499.5);
      trace[i]->GetXaxis()->SetTitle("time");
      trace[i]->GetYaxis()->SetTitle("Amplitude");

    }

  h2 = new TH2F( "h2", "sample vs channel ", 28, -0.5, 27.5, CARDS*128, -0.5,  CARDS*128-0.5);
  h2->GetXaxis()->SetTitle("sample number");
  h2->GetYaxis()->SetTitle("channel");
  h2->GetXaxis()->SetTitleOffset(1.5);
  h2->GetYaxis()->SetTitleOffset(1.7);

  h3 = new TH2F( "h3", "sample vs channel baseline corrected", 28, -0.5, 27.5, CARDS*128, -0.5,  CARDS*128-0.5);
  h3->GetXaxis()->SetTitle("sample number");
  h3->GetYaxis()->SetTitle("channel");
  h3->GetXaxis()->SetTitleOffset(1.5);
  h3->GetYaxis()->SetTitleOffset(1.7);

  return 0;

}

int process_event (Event * e)
{

  int i;

  for ( i = 0; i < CARDS ; i++)
    {
      trace[i]->Reset();
    }

  h2->Reset();
  h3->Reset();

  Packet *p = e->getPacket(1010);
  if (p)
    {
      int s, h, c, i;

      for ( h = 0; h < CARDS; h++)  // hybrids
	{

	  for (i = 0; i< 4500; i++)
	    {
	      trace[h]->Fill( i, p->iValue(i, 2*h, "RAWSAMPLES"));
	    }
	  //	  cout << " samples " << 2 * h << "  " << p->iValue(h*2,"NSAMPLES") << endl;
	  
	}

      for ( h = 0; h < CARDS; h++)  // hybrids
	{
	  for ( c = 0; c < 128; c++)
	    {
	      // make a crude baseline from the last 3 samples
	      double baseline = 0;
	      double baseline_early = 0;
	      double baseline_late = 0;
	      for (s = 0; s< 3; s++)
		{
		  baseline_early +=  p->iValue ( c, s, 2*h);
		}
	      for (s = 25; s< 28; s++)
		{
		  baseline_late +=  p->iValue ( c, s, 2*h);
		}
	      if ( baseline_early > baseline_late)
		{
		  baseline = baseline_early;
		}
	      else
		{
		  baseline = baseline_late;
		}
	      baseline /= 3.;
	    
	      for (s = 0; s< 28; s++)
		{
		  h2-> Fill ( s, h*128 + c,  -1 *  p->iValue ( c, s, 2*h) ); 
		  h3-> Fill ( s, h*128 + c,  baseline -  p->iValue ( c, s, 2*h) ); 
		}

	    }


	}
  
      delete p;
    }

  //  usleep(1000000);
  return 0;
}

